precision mediump float;
uniform sampler2D u_TextureUnit;
varying vec3 v_Color;
varying float v_ElapsedTime;
void main()
{
    /*            
    float xDistance = 0.5 - gl_PointCoord.x;
    float yDistance = 0.5 - gl_PointCoord.y;
    float distanceFromCenter = 
        sqrt(xDistance * xDistance + yDistance * yDistance);
    gl_FragColor = vec4(v_Color / v_ElapsedTime, 1.0);
    
    if (distanceFromCenter > 0.5) {
        discard;
    } else {            
        gl_FragColor = vec4(v_Color / v_ElapsedTime, 1.0);        
    }
    */
    //    gl_FragColor = vec4(v_Color / v_ElapsedTime, 1.0)
    //                 * texture2D(u_TextureUnit, gl_PointCoord);

    // 时间因子，取值范围 [1.0 -> 0.0)，用于影响缩放
    float animDuration = 5.0;  // 5秒动画效果
    float elapsedFactor = 1.0 - (v_ElapsedTime / animDuration);
    if (elapsedFactor < 0.0) {
        elapsedFactor = 0.0;
    }

    // 纹理缩放
    float maxScale = 1.5;
    float startScale = 1.0;
    float curScale = maxScale - (elapsedFactor * (maxScale - startScale));// [1.0 => 1.5]
    mat4 vTextureScaleMat = mat4(curScale);
    vec4 texColor = texture2D(u_TextureUnit, (vTextureScaleMat * vec4(gl_PointCoord - vec2(0.5), 0.0, 1.0)).xy + vec2(0.5));

    gl_FragColor = vec4(texColor.rgb * elapsedFactor, texColor.a * elapsedFactor);
}
